diff --git a/stand/efi/loader/xhci_dbc_cons.c b/stand/efi/loader/xhci_dbc_cons.c
new file mode 100644
index 000000000000..21c95f9079d6
--- /dev/null
+++ b/stand/efi/loader/xhci_dbc_cons.c
@@ -0,0 +1,244 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/param.h>
+#include <dev/pci/pcireg.h>
+#include <dev/usb/controller/xhcireg.h>
+
+#include <bootstrap.h>
+#include <efi.h>
+#include <efilib.h>
+
+#include "pci.h"
+#include "xhci_dbc_cons.h"
+#include "xhci_dbc_pci.h"
+#include "xhci_dbc_dma.h"	/* udb_init_dma() */
+#include <dev/usb/controller/xhci_private.h>
+#include <dev/usb/controller/xhci_dbc.h>
+#include <dev/usb/controller/xhci_dbc_private.h>
+
+static void udbc_probe(struct console *);
+static int udbc_getc(void);
+static void udbc_putc(int);
+static int udbc_ischar(void);
+static int udbc_init(int);
+struct console udb_console = {
+	.c_name = "udbc",
+	.c_desc = "USB DbC serial port",
+	.c_flags = 0,
+	.c_probe = udbc_probe,
+	.c_init = udbc_init,
+	.c_out = udbc_putc,
+	.c_in = udbc_getc,
+	.c_ready = udbc_ischar
+};
+
+struct xhci_debug_softc *udb_sc;
+
+static void
+udbc_probe(struct console *cons)
+{
+	struct xhci_debug_softc *sc;
+	EFI_STATUS status;
+	EFI_HANDLE *h0, *h;
+	EFI_PCI_IO_PROTOCOL *pciio;
+	UINTN hlen;
+	uint32_t devfn;
+	char buf[32];
+	int i, error;
+	int found;
+
+	h0 = h = NULL;
+	if (udb_sc != NULL)
+		return;
+
+	/* Get PCI I/O handle. */
+	hlen = 0;
+	status = BS->LocateHandle(ByProtocol, &pciio_guid, NULL, &hlen, NULL);
+	DEBUG_PRINTF("%s: LocateHandle1 = %lx\n", __func__, status);
+	if (status != EFI_BUFFER_TOO_SMALL)
+		goto error;
+	h0 = malloc(hlen);
+	status = BS->LocateHandle(ByProtocol, &pciio_guid, NULL, &hlen, h0);
+	DEBUG_PRINTF("%s: LocateHandle2 = %lu\n", __func__, status);
+	if (status != EFI_SUCCESS)
+		goto error;
+	hlen /= sizeof(EFI_HANDLE);
+
+	/* Look up vendor IDs. */
+	found = 0;
+	for (h = h0; h < h0 + hlen; h++) {
+		UINT32 dev_ven;
+
+		status = OpenProtocolByHandle(*h, &pciio_guid,
+		    (void **)&pciio);
+		if (status != EFI_SUCCESS)
+			continue;
+		status = pciio->Pci.Read(pciio, EfiPciIoWidthUint32,
+		    PCIR_DEVVENDOR, 1, &dev_ven);
+		if (status != EFI_SUCCESS) {
+			BS->CloseProtocol(h, &pciio_guid, IH, NULL);
+			continue;
+		}
+		DEBUG_PRINTF("%s: dev_ven = %08x\n", __func__, dev_ven);
+		for (i = 0; i < nitems(ids); i++) {
+			if (dev_ven ==
+			    ((ids[i].device << 16) | ids[i].vendor)) {
+				found = 1;
+				break;
+			}
+		}
+	}
+	if (found == 0)
+		goto error;
+
+	sc = udb_sc_malloc(sizeof(*sc), h, pciio);
+	if (sc == NULL)
+		return;
+	udb_sc = sc;
+	sc->sc_cons = cons;
+
+	h0 = NULL;
+	for (devfn = 0; devfn < 256; devfn++) {
+		uint32_t sc_ca;
+		uint32_t header_type;
+		uint32_t class;
+
+		sc_ca = 0;
+		sc_ca |= PCIR_IO_CA_ENABLE;
+		sc_ca |= PCIR_IO_CA_DEV_SET(devfn >> 3);
+		sc_ca |= PCIR_IO_CA_FUN_SET(devfn);
+
+		header_type =
+		    (pci_read_config(sc_ca, PCIR_CA_HEADER) >> 16) & 0xff;
+
+		if (header_type != PCIM_HDRTYPE_NORMAL &&
+		    header_type != PCIM_MFDEV)
+			continue;
+		class = pci_read_config(sc_ca, PCIR_CA_CLASS) >> 8;
+		if (class == XHC_CLASSC) {
+			sc->sc_ca = sc_ca;
+			break;
+		}
+	}
+	if (sc->sc_ca == 0) {
+		DEBUG_PRINTF("%s: Compatible xHC not found.\n", __func__);
+		goto error;
+	}
+	if (!xhci_debug_probe(sc))
+		goto error;
+
+	xhci_debug_disable(sc);
+	cons->c_flags = C_PRESENTIN | C_PRESENTOUT;
+
+	xhci_debug_update_state(sc);
+	if (sc->sc_init == false) {
+		error = xhci_debug_init_dma(sc);
+		if (error) {
+			DEBUG_PRINTF("USB DbC DMA configuration error\n");
+			goto error;
+		}
+		error = xhci_debug_init_ring(sc);
+		if (error) {
+			DEBUG_PRINTF("USB DbC TRB ring configuration error\n");
+			goto error;
+		}
+		sc->sc_init = true;
+	}
+	xhci_debug_enable(sc);
+	xhci_debug_update_state(sc);
+
+	return;
+error:
+	free(h0);
+	free(sc);
+	sc = NULL;
+	return;
+}
+
+static int
+udbc_init(int arg)
+{
+	struct xhci_debug_softc *sc = udb_sc;
+	int error;
+
+	if (sc == NULL) {		/* allocated in c_probe */
+		DEBUG_PRINTF("USB DbC not found\n");
+		return (CMD_ERROR);
+	}
+	if (sc->sc_dbc_off == 0) {	/* set in c_probe */
+		DEBUG_PRINTF("USB DbC register not found\n");
+		return (CMD_ERROR);
+	}
+	xhci_debug_enable(sc);
+	xhci_debug_event_dequeue(sc);
+
+	return (CMD_OK);
+}
+
+static void
+udbc_putc(int c0)
+{
+	struct xhci_debug_softc *sc = udb_sc;
+	u_char c = (0xff & c0);
+
+	if (sc == NULL)
+		return;
+	if (!work_enqueue(&sc->udb_oring, &c, sizeof(c)))
+		return;
+	xhci_debug_bulk_transfer(sc, &sc->udb_oring);
+}
+
+static int
+udbc_getc(void)
+{
+	struct xhci_debug_softc *sc = udb_sc;
+
+	if (sc == NULL)
+		return (-1);
+
+	/* Use udbc_ischar() to receive data */
+	return (udbc_ischar() ? work_dequeue(&sc->udb_iring) : -1);
+}
+
+static int
+udbc_ischar(void)
+{
+	struct xhci_debug_softc *sc = udb_sc;
+	struct xhci_debug_ring *iring;
+
+	if (sc == NULL)
+		return (0);
+	if (!UDB_WORK_RING_EMPTY(iring))
+		return (1);
+	
+	iring = &sc->udb_iring;
+	xhci_debug_bulk_transfer(sc, iring);
+	xhci_debug_event_dequeue(sc);
+
+	return (!UDB_WORK_RING_EMPTY(iring));
+}
diff --git a/stand/efi/loader/xhci_dbc_cons.h b/stand/efi/loader/xhci_dbc_cons.h
new file mode 100644
index 000000000000..d9c9886b8c47
--- /dev/null
+++ b/stand/efi/loader/xhci_dbc_cons.h
@@ -0,0 +1,29 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+extern struct console udb_console;
+extern struct xhci_debug_softc *udb_sc;
diff --git a/stand/efi/loader/xhci_dbc_dma.c b/stand/efi/loader/xhci_dbc_dma.c
new file mode 100644
index 000000000000..c7c8d97a342d
--- /dev/null
+++ b/stand/efi/loader/xhci_dbc_dma.c
@@ -0,0 +1,346 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/param.h>
+#include <dev/pci/pcireg.h>
+#include <dev/usb/controller/xhcireg.h>
+
+#include <assert.h>
+
+#include <bootstrap.h>
+#include <efi.h>
+#include <efilib.h>
+
+#include "pci.h"
+#include "xhci_dbc_pci.h"
+#include <dev/usb/controller/xhci_private.h>
+#include <dev/usb/controller/xhci_dbc.h>
+#include <dev/usb/controller/xhci_dbc_private.h>
+
+#include "xhci_dbc_dma.h"
+
+EFI_GUID pciio_guid = EFI_PCI_IO_PROTOCOL_GUID;
+
+static void *udb_alloc_dma(struct xhci_debug_softc *, uint64_t);
+static void udb_free_dma(struct xhci_debug_softc *, VOID *);
+static uint64_t v2p(struct xhci_debug_softc *, void *);
+
+uint64_t
+v2p(struct xhci_debug_softc *sc, void *virt)
+{
+	UINTN i;
+	UINTN p;
+	UINTN offset;
+	UINTN needed;
+	UINTN mapped;
+	struct dma *dma;
+	EFI_PCI_IO_PROTOCOL *pci;
+	EFI_STATUS status;
+	EFI_PHYSICAL_ADDRESS paddr;
+	VOID *mapping;
+
+	dma = NULL;
+	pci = sc->sc_efi_pciio;
+	for (i = 0; i < DMA_DESC_CAP; i++) {
+		dma = &sc->dma_desc[i];
+
+		DEBUG_V_PRINTF("%s: dma_desc[%lu].cpu_addr = %p\n", __func__,
+		    i, dma->cpu_addr);
+		for (p = 0; p < dma->pages; p++) {
+			UINTN addr = (UINTN)dma->cpu_addr + (p * PAGE_SIZE);
+
+			DEBUG_V_PRINTF("%s: check addr: %lu = %lu + %lu * %u\n",
+			    __func__, addr, (UINTN)dma->cpu_addr, p, PAGE_SIZE);
+			if ((UINTN)virt == addr) {
+				offset = addr - (UINTN)dma->cpu_addr;
+				goto found;
+			}
+		}
+		dma = NULL;
+	}
+	if (dma == NULL) {
+		DEBUG_PRINTF("CPU addr %p not found in DMA descriptor\n", virt);
+		return 0;
+	}
+
+found:
+#if 0
+	DEBUG_PRINTF("%s: found, i = %lu, dma->paddr = %lu, offset = %lu\n",
+	    __func__, i, dma->paddr, offset);
+#endif
+	if (dma->paddr && dma->mapping)
+		return (dma->paddr + offset);
+
+	needed = dma->pages << EFI_PAGE_SHIFT;
+	mapped = needed;
+	status = pci->Map(pci, EfiPciIoOperationBusMasterCommonBuffer,
+	    (void *)virt, &mapped, &paddr, &mapping);
+	if (EFI_ERROR(status) || mapped != needed) {
+		DEBUG_PRINTF("pci->Map failed: rc: 0x%lx, mapped: %lu, needed: %lu\n",
+		    status, mapped, needed);
+		return (0);
+	}
+	dma->paddr = paddr;
+	dma->mapping = mapping;
+
+	if ((const void *)paddr != virt) {
+		DEBUG_PRINTF("Non-identity DMA mapping: dma: 0x%lx cpu: %p\n",
+		    paddr, virt);
+	}
+
+	return (paddr);
+}
+
+struct xhci_debug_softc *
+udb_sc_malloc(size_t len, EFI_HANDLE *h, EFI_PCI_IO_PROTOCOL *pciio)
+{
+	struct xhci_debug_softc *sc;
+	EFI_STATUS status;
+	VOID *addr;
+	int pages;
+
+	sc = NULL;
+	pages = sizeof(*sc) / PAGE_SIZE + 1;
+	status = pciio->AllocateBuffer(pciio,
+	    AllocateAnyPages,
+	    EfiRuntimeServicesData,
+	    sizeof(*sc) / PAGE_SIZE + 1,
+	    &addr,
+	    EFI_PCI_IO_ATTRIBUTE_MEMORY_CACHED);
+	if (EFI_ERROR(status)) {
+		DEBUG_PRINTF("%s: AllocateBuffer failed: 0x%lx\n",
+		    __func__, status);
+		return (NULL);
+	}
+	memset(addr, 0, sizeof(*sc));
+	sc = (struct xhci_debug_softc *)addr;
+
+	sc->dma_desc[0].pages = pages;
+	sc->dma_desc[0].cpu_addr = addr;
+	sc->sc_efi_pciio = pciio;
+	sc->sc_efi_hand = h;
+	sc->dma_allocated = false;
+	sc->sc_init = false;
+
+	return (sc);
+}
+
+int
+xhci_debug_init_dma(struct xhci_debug_softc *sc)
+{
+	struct xhci_debug_softc *sc_udb;
+	char buf[1024];
+#define	ALLOC_DMA(p, type, order)				\
+	do { 							\
+		p = (type)udb_alloc_dma(sc, order); 		\
+		if (p == NULL) { 				\
+			xhci_debug_uninit_dma(sc);		\
+			return (1);				\
+		}						\
+	} while (0)
+
+	if (sc->dma_allocated)
+		return (0);
+
+	/* Export softc */
+	snprintf(buf, sizeof(buf), "%p", (void *)(uintptr_t)v2p(sc, sc));
+	buf[sizeof(buf) - 1] = '\0';
+	setenv("hw.usb.xhci.dbc.softc.paddr", buf, 1);
+	snprintf(buf, sizeof(buf), "%zu", sizeof(*sc));
+	buf[sizeof(buf) - 1] = '\0';
+	setenv("hw.usb.xhci.dbc.softc.len", buf, 1);
+
+	ALLOC_DMA(sc->udb_ctx, struct xhci_debug_ctx *, 0);
+	ALLOC_DMA(sc->udb_erst, struct xhci_event_ring_seg *, 0);
+	ALLOC_DMA(sc->udb_ering.trb, struct xhci_trb *, UDB_TRB_RING_ORDER);
+	ALLOC_DMA(sc->udb_iring.trb, struct xhci_trb *, UDB_TRB_RING_ORDER);
+	ALLOC_DMA(sc->udb_oring.trb, struct xhci_trb *, UDB_TRB_RING_ORDER);
+	ALLOC_DMA(sc->udb_iring.work.buf, uint8_t *, UDB_WORK_RING_ORDER);
+	ALLOC_DMA(sc->udb_oring.work.buf, uint8_t *, UDB_WORK_RING_ORDER);
+	ALLOC_DMA(sc->udb_str, char *, 0);
+
+	/* Export CTX, ERST, and STR */
+#define	SETADDR(n, len) do { \
+		sc->udb_##n##_paddr = (uintptr_t)v2p(sc, sc->udb_##n); \
+		snprintf(buf, sizeof(buf), "%p", \
+		    (void *)v2p(sc, sc->udb_##n)); \
+		buf[sizeof(buf) - 1] = '\0'; \
+		setenv("hw.usb.xhci.dbc." #n ".paddr", buf, 1); \
+		snprintf(buf, sizeof(buf), "%lu", \
+		    (uint64_t)len); \
+		buf[sizeof(buf) - 1] = '\0'; \
+		setenv("hw.usb.xhci.dbc." #n ".len", buf, 1); \
+	} while (0)
+	SETADDR(ctx, PAGE_SIZE);
+	SETADDR(erst, PAGE_SIZE);
+	SETADDR(str, PAGE_SIZE);
+
+	/* Export TRB rings. */
+#define	SETADDR_RING(n, paddr, trb, len) do { \
+		sc->udb_##paddr = (uintptr_t)v2p(sc, sc->udb_##trb); \
+		snprintf(buf, sizeof(buf), "%p", (void *)sc->udb_##paddr); \
+		buf[sizeof(buf) - 1] = '\0'; \
+		setenv("hw.usb.xhci.dbc." #paddr, buf, 1); \
+		snprintf(buf, sizeof(buf), "%lu", (uint64_t)len); \
+		buf[sizeof(buf) - 1] = '\0'; \
+		setenv("hw.usb.xhci.dbc." #n ".len", buf, 1); \
+	} while (0)
+	
+	SETADDR_RING(ering, ering.paddr, ering.trb,
+	    PAGE_SIZE * (1UL << UDB_TRB_RING_ORDER));
+	SETADDR_RING(iring, iring.paddr, iring.trb,
+	    PAGE_SIZE * (1UL << UDB_TRB_RING_ORDER));
+	SETADDR_RING(oring, oring.paddr, oring.trb,
+	    PAGE_SIZE * (1UL << UDB_TRB_RING_ORDER));
+	SETADDR_RING(iring.work, iring.work.paddr, iring.work.buf,
+	    PAGE_SIZE * (1UL << UDB_WORK_RING_ORDER));
+	SETADDR_RING(oring.work, oring.work.paddr, oring.work.buf,
+	    PAGE_SIZE * (1UL << UDB_WORK_RING_ORDER));
+
+	sc->dma_allocated = true;
+
+	return (0);
+#undef	ALLOC_DMA
+}
+
+static void *
+udb_alloc_dma(struct xhci_debug_softc *sc, uint64_t order)
+{
+	struct dma *dma;
+	EFI_STATUS status;
+	VOID *addr;
+	UINTN pages = 1UL << order;
+	UINTN i;
+
+	for (i = 0; i < DMA_DESC_CAP; i++) {
+		dma = &sc->dma_desc[i];
+		if (dma->cpu_addr == NULL)
+			break;
+	}
+	if (i == DMA_DESC_CAP) {
+		DEBUG_PRINTF("%s: Out of DMA descriptor\n", __func__);
+		return (NULL);
+	}
+	status = sc->sc_efi_pciio->AllocateBuffer(sc->sc_efi_pciio,
+	    AllocateAnyPages,
+	    EfiRuntimeServicesData,
+	    pages,
+	    &addr,
+	    EFI_PCI_IO_ATTRIBUTE_MEMORY_CACHED);
+	if (EFI_ERROR(status)) {
+		DEBUG_PRINTF("%s: AllocateBuffer failed: 0x%lx\n",
+		    __func__, status);
+		return (NULL);
+	}
+
+	dma->pages = pages;
+	dma->cpu_addr = addr;
+	DEBUG_PRINTF("%s: i = %lu, cpu_addr = %p, pages = %lu\n", __func__,
+	    i, dma->cpu_addr, pages);
+
+	return (addr);
+}
+
+static void
+udb_free_dma(struct xhci_debug_softc *sc, VOID *addr)
+{
+	struct dma *dma;
+	EFI_STATUS status;
+	UINTN i;
+
+	for (i = 0; i < DMA_DESC_CAP; i++) {
+		dma = &sc->dma_desc[i];
+		if (dma->cpu_addr == addr)
+			break;
+	}
+	if (i == DMA_DESC_CAP)
+		return;
+	if (dma->mapping) {
+		status = sc->sc_efi_pciio->Unmap(sc->sc_efi_pciio,
+		    dma->mapping);
+		if (EFI_ERROR(status)) {
+			DEBUG_PRINTF("%s: Unmap failed: 0x%lx\n",
+			    __func__, status);
+			return;
+		}
+	}
+	status = sc->sc_efi_pciio->FreeBuffer(sc->sc_efi_pciio, dma->pages,
+	    addr);
+	if (EFI_ERROR(status)) {
+		DEBUG_PRINTF("%s: FreeBuffer failed: 0x%lx\n",
+		    __func__, status);
+		return;
+	}
+	memset(&dma, 0, sizeof(*dma));
+}
+
+void
+xhci_debug_uninit_dma(struct xhci_debug_softc *sc)
+{
+	udb_free_dma(sc, sc->udb_ctx);
+	udb_free_dma(sc, sc->udb_erst);
+	udb_free_dma(sc, sc->udb_ering.trb);
+	udb_free_dma(sc, sc->udb_oring.trb);
+	udb_free_dma(sc, sc->udb_iring.trb);
+	udb_free_dma(sc, sc->udb_oring.work.buf);
+	udb_free_dma(sc, sc->udb_iring.work.buf);
+
+	sc->dma_allocated = false;
+}
+
+int
+xhci_debug_pci_mmio_init(struct xhci_debug_softc *sc)
+{
+	volatile uint32_t barl;	/* volatile is required. */
+	volatile uint32_t barh;	/* volatile is required. */
+
+	/* Parse the BAR and map the registers */
+	barl = pci_read_config(sc->sc_ca, PCIR_CA_BAR_LO);
+	barh = pci_read_config(sc->sc_ca, PCIR_CA_BAR_HI);
+
+	if ((barl & 0x1) != 0 || ((barl & 0x6) >> 1) != 2) {
+		DEBUG_PRINTF("%s: BAR must be 64-bit.\n", __func__);
+		return (0);
+	}
+
+	pci_write_config(sc->sc_ca, PCIR_CA_BAR_LO, 0xffffffff);
+	sc->sc_mmio_size =
+	    ~(pci_read_config(sc->sc_ca, PCIR_CA_BAR_LO) & 0xfffffff0) + 1;
+	pci_write_config(sc->sc_ca, PCIR_CA_BAR_LO, barl);
+
+	/* XXX: This assumes 64-bit. */
+	sc->sc_mmio_phys =
+	    (uintptr_t)(((uint64_t)barl & 0xfffffff0) | ((uint64_t)barh << 32));
+	sc->sc_mmio = (void *)sc->sc_mmio_phys;
+	sc->sc_capa_off = 0;
+
+	if (sc->sc_mmio == NULL) {
+		DEBUG_PRINTF("%s: mmio_phys is NULL.\n", __func__);
+		return (0);
+	}
+	return (1);
+}
diff --git a/stand/efi/loader/xhci_dbc_dma.h b/stand/efi/loader/xhci_dbc_dma.h
new file mode 100644
index 000000000000..c4cfa256ce75
--- /dev/null
+++ b/stand/efi/loader/xhci_dbc_dma.h
@@ -0,0 +1,35 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+int xhci_debug_init_dma(struct xhci_debug_softc *);
+void xhci_debug_uninit_dma(struct xhci_debug_softc *);
+int xhci_debug_pci_mmio_init(struct xhci_debug_softc *);
+
+struct xhci_debug_softc *udb_sc_malloc(size_t, EFI_HANDLE *,
+    EFI_PCI_IO_PROTOCOL *);
+
+extern EFI_GUID pciio_guid;
diff --git a/stand/efi/loader/xhci_dbc_pci.h b/stand/efi/loader/xhci_dbc_pci.h
new file mode 100644
index 000000000000..44bdf44d4287
--- /dev/null
+++ b/stand/efi/loader/xhci_dbc_pci.h
@@ -0,0 +1,125 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+/* Supported xHC PCI configurations */
+#define XHC_CLASSC		0x0c0330ULL
+#define XHC_VEN_INTEL		0x8086ULL
+
+#define	XHC_DEV_COMET_LAKE_LP	0x02edULL
+#define	XHC_DEV_COMET_LAKE	0x06edULL
+#define	XHC_DEV_N2000		0x0f35ULL
+#define	XHC_DEV_C3000		0x19d0ULL
+#define	XHC_DEV_C210		0x1e31ULL
+#define	XHC_DEV_E8000		0x22b5ULL
+#define	XHC_DEV_PUMA		0x2bb5ULL
+#define	XHC_DEV_CELERON		0x31a8ULL
+#define	XHC_DEV_ICE_LAKE	0x34edULL
+#define	XHC_DEV_TIGER_LAKE_H	0x43edULL
+#define	XHC_DEV_N3350		0x5aa8ULL
+#define	XHC_DEV_C220		0x8c31ULL
+#define	XHC_DEV_NINE		0x8cb1ULL
+#define	XHC_DEV_C610		0x8d31ULL
+#define	XHC_DEV_EIGHT		0x9c31ULL
+#define	XHC_DEV_WILDCAT_POINT	0x9cb1ULL
+#define	XHC_DEV_SUNRISE_POINT	0x9d2fULL
+#define	XHC_DEV_CANNON_POINT	0x9dedULL
+#define	XHC_DEV_SILVER		0x31a8ULL
+#define	XHC_DEV_TIGER_LAKE	0xa0edULL
+#define	XHC_DEV_C230		0xa12fULL
+#define	XHC_DEV_C620		0xa1afULL
+#define	XHC_DEV_Z370		0xa2afULL
+#define	XHC_DEV_CANNON_LAKE	0xa36dULL
+
+#define XHC_VEN_AMD		0x1022ULL
+
+#define	XHC_DEV_KERNCZ		0x145cULL
+#define	XHC_DEV_STARSHIP	0x148cULL
+#define	XHC_DEV_MATISSE		0x149cULL
+#define	XHC_DEV_X399		0x43baULL
+#define	XHC_DEV_X370		0x43b9ULL
+#define	XHC_DEV_B350		0x43bbULL
+#define	XHC_DEV_400		0x43d5ULL
+#define	XHC_DEV_FCH_1		0x7812ULL
+#define	XHC_DEV_FCH_2		0x7814ULL
+#define	XHC_DEV_FCH_3		0x7914ULL
+
+#define XHC_VEN_VMWARE		0x15adULL
+#define	XHC_DEV_VMWARE_1	0x0778ULL
+#define	XHC_DEV_VMWARE_2	0x0779ULL
+
+#define XHC_VEN_ASMEDIA		0x1b21ULL
+#define XHC_DEV_ASM1042		0x1042ULL
+#define XHC_DEV_ASM1042A	0x1142ULL
+#define XHC_DEV_ASM1143		0x1343ULL
+#define XHC_DEV_ASM3242		0x3242ULL
+
+static struct pciid ids[] = {
+	{ XHC_VEN_INTEL, XHC_DEV_COMET_LAKE_LP },
+	{ XHC_VEN_INTEL, XHC_DEV_COMET_LAKE },
+	{ XHC_VEN_INTEL, XHC_DEV_N2000 },
+	{ XHC_VEN_INTEL, XHC_DEV_C3000 },
+	{ XHC_VEN_INTEL, XHC_DEV_C210 },
+	{ XHC_VEN_INTEL, XHC_DEV_E8000 },
+	{ XHC_VEN_INTEL, XHC_DEV_PUMA },
+	{ XHC_VEN_INTEL, XHC_DEV_CELERON },
+	{ XHC_VEN_INTEL, XHC_DEV_ICE_LAKE },
+	{ XHC_VEN_INTEL, XHC_DEV_TIGER_LAKE_H },
+	{ XHC_VEN_INTEL, XHC_DEV_N3350 },
+	{ XHC_VEN_INTEL, XHC_DEV_C220 },
+	{ XHC_VEN_INTEL, XHC_DEV_NINE },
+	{ XHC_VEN_INTEL, XHC_DEV_C610 },
+	{ XHC_VEN_INTEL, XHC_DEV_EIGHT },
+	{ XHC_VEN_INTEL, XHC_DEV_WILDCAT_POINT },
+	{ XHC_VEN_INTEL, XHC_DEV_SUNRISE_POINT },
+	{ XHC_VEN_INTEL, XHC_DEV_CANNON_POINT },
+	{ XHC_VEN_INTEL, XHC_DEV_SILVER },
+	{ XHC_VEN_INTEL, XHC_DEV_TIGER_LAKE },
+	{ XHC_VEN_INTEL, XHC_DEV_C230 },
+	{ XHC_VEN_INTEL, XHC_DEV_C620 },
+	{ XHC_VEN_INTEL, XHC_DEV_Z370 },
+	{ XHC_VEN_INTEL, XHC_DEV_CANNON_LAKE },
+
+	{ XHC_VEN_AMD, XHC_DEV_KERNCZ },
+	{ XHC_VEN_AMD, XHC_DEV_STARSHIP },
+	{ XHC_VEN_AMD, XHC_DEV_MATISSE },
+	{ XHC_VEN_AMD, XHC_DEV_X399 },
+	{ XHC_VEN_AMD, XHC_DEV_X370 },
+	{ XHC_VEN_AMD, XHC_DEV_B350 },
+	{ XHC_VEN_AMD, XHC_DEV_400 },
+	{ XHC_VEN_AMD, XHC_DEV_FCH_1 },
+	{ XHC_VEN_AMD, XHC_DEV_FCH_2 },
+	{ XHC_VEN_AMD, XHC_DEV_FCH_3 },
+
+	{ XHC_VEN_VMWARE, XHC_DEV_VMWARE_1 },
+	{ XHC_VEN_VMWARE, XHC_DEV_VMWARE_2 },
+
+	{ XHC_VEN_ASMEDIA, XHC_DEV_ASM1042 },
+	{ XHC_VEN_ASMEDIA, XHC_DEV_ASM1042A },
+	{ XHC_VEN_ASMEDIA, XHC_DEV_ASM1143 },
+	{ XHC_VEN_ASMEDIA, XHC_DEV_ASM3242 },
+	{ 0, 0 }
+};
diff --git a/sys/amd64/amd64/machdep.c b/sys/amd64/amd64/machdep.c
index ea440f46a12f..b1909909f201 100644
--- a/sys/amd64/amd64/machdep.c
+++ b/sys/amd64/amd64/machdep.c
@@ -866,6 +866,12 @@ getmemsize(caddr_t kmdp, u_int64_t first)
 	u_long physmem_start, physmem_tunable, memtest;
 	pt_entry_t *pte;
 	quad_t dcons_addr, dcons_size;
+	quad_t xhci_dbc_ering_addr, xhci_dbc_ering_len;
+	quad_t xhci_dbc_iring_addr, xhci_dbc_iring_len;
+	quad_t xhci_dbc_oring_addr, xhci_dbc_oring_len;
+	quad_t xhci_dbc_iring_work_addr, xhci_dbc_iring_work_len;
+	quad_t xhci_dbc_oring_work_addr, xhci_dbc_oring_work_len;
+	quad_t xhci_dbc_softc_addr, xhci_dbc_softc_len;
 	int page_counter;
 
 	TSENTER();
@@ -970,6 +976,24 @@ getmemsize(caddr_t kmdp, u_int64_t first)
 	    getenv_quad("dcons.size", &dcons_size) == 0)
 		dcons_addr = 0;
 
+	/*
+	 * Get XHCI DbC TRB ring addresses
+	 */
+	getenv_quad("hw.usb.xhci.dbc.ering.paddr", &xhci_dbc_ering_addr);
+	getenv_quad("hw.usb.xhci.dbc.ering.len", &xhci_dbc_ering_len);
+	getenv_quad("hw.usb.xhci.dbc.iring.paddr", &xhci_dbc_iring_addr);
+	getenv_quad("hw.usb.xhci.dbc.iring.len", &xhci_dbc_iring_len);
+	getenv_quad("hw.usb.xhci.dbc.oring.paddr", &xhci_dbc_oring_addr);
+	getenv_quad("hw.usb.xhci.dbc.oring.len", &xhci_dbc_oring_len);
+
+	getenv_quad("hw.usb.xhci.dbc.oring.work.paddr", &xhci_dbc_oring_work_addr);
+	getenv_quad("hw.usb.xhci.dbc.oring.work.len", &xhci_dbc_oring_work_len);
+
+	getenv_quad("hw.usb.xhci.dbc.iring.work.paddr", &xhci_dbc_iring_work_addr);
+	getenv_quad("hw.usb.xhci.dbc.iring.work.len", &xhci_dbc_iring_work_len);
+	getenv_quad("hw.usb.xhci.dbc.softc.paddr", &xhci_dbc_softc_addr);
+	getenv_quad("hw.usb.xhci.dbc.softc.len", &xhci_dbc_softc_len);
+
 	/*
 	 * physmap is in bytes, so when converting to page boundaries,
 	 * round up the start address and round down the end address.
@@ -1001,6 +1025,16 @@ getmemsize(caddr_t kmdp, u_int64_t first)
 			    && pa >= trunc_page(dcons_addr)
 			    && pa < dcons_addr + dcons_size)
 				goto do_dump_avail;
+#define	BLOCKOUT(addr, len) do { \
+	if (addr > 0 && pa >= trunc_page(addr) && pa < addr + len) \
+		goto do_dump_avail; \
+	} while (0)
+			BLOCKOUT(xhci_dbc_ering_addr, xhci_dbc_ering_len);
+			BLOCKOUT(xhci_dbc_iring_addr, xhci_dbc_iring_len);
+			BLOCKOUT(xhci_dbc_oring_addr, xhci_dbc_oring_len);
+			BLOCKOUT(xhci_dbc_iring_work_addr, xhci_dbc_iring_work_len);
+			BLOCKOUT(xhci_dbc_oring_work_addr, xhci_dbc_oring_work_len);
+			BLOCKOUT(xhci_dbc_softc_addr, xhci_dbc_softc_len);
 
 			page_bad = FALSE;
 			if (memtest == 0)
diff --git a/sys/amd64/amd64/mp_machdep.c b/sys/amd64/amd64/mp_machdep.c
index d506ffada4b9..91737637b714 100644
--- a/sys/amd64/amd64/mp_machdep.c
+++ b/sys/amd64/amd64/mp_machdep.c
@@ -102,13 +102,16 @@ void *bootpcpu;
 
 extern u_int mptramp_la57;
 extern u_int mptramp_nx;
-
+smp_targeted_tlb_shootdown_t smp_targeted_tlb_shootdown = &smp_targeted_tlb_shootdown_native;
 /*
  * Local data and functions.
  */
 
 static int start_ap(int apic_id, vm_paddr_t boot_address);
 
+void
+smp_targeted_tlb_shootdown_native(pmap_t pmap, vm_offset_t addr1, vm_offset_t addr2,
+    smp_invl_cb_t curcpu_cb, enum invl_op_codes op);
 /*
  * Initialize the IPI handlers and start up the AP's.
  */
@@ -497,24 +500,6 @@ start_ap(int apic_id, vm_paddr_t boot_address)
  * Flush the TLB on other CPU's
  */
 
-/*
- * Invalidation request.  PCPU pc_smp_tlb_op uses u_int instead of the
- * enum to avoid both namespace and ABI issues (with enums).
- */
-enum invl_op_codes {
-      INVL_OP_TLB		= 1,
-      INVL_OP_TLB_INVPCID	= 2,
-      INVL_OP_TLB_INVPCID_PTI	= 3,
-      INVL_OP_TLB_PCID		= 4,
-      INVL_OP_PGRNG		= 5,
-      INVL_OP_PGRNG_INVPCID	= 6,
-      INVL_OP_PGRNG_PCID	= 7,
-      INVL_OP_PG		= 8,
-      INVL_OP_PG_INVPCID	= 9,
-      INVL_OP_PG_PCID		= 10,
-      INVL_OP_CACHE		= 11,
-};
-
 /*
  * These variables are initialized at startup to reflect how each of
  * the different kinds of invalidations should be performed on the
@@ -600,8 +585,8 @@ invl_scoreboard_slot(u_int cpu)
  * Function must be called with the thread pinned, and it unpins on
  * completion.
  */
-static void
-smp_targeted_tlb_shootdown(pmap_t pmap, vm_offset_t addr1, vm_offset_t addr2,
+void
+smp_targeted_tlb_shootdown_native(pmap_t pmap, vm_offset_t addr1, vm_offset_t addr2,
     smp_invl_cb_t curcpu_cb, enum invl_op_codes op)
 {
 	cpuset_t mask;
diff --git a/sys/amd64/amd64/pmap.c b/sys/amd64/amd64/pmap.c
index 233069d37bfb..d6e9713f215a 100644
--- a/sys/amd64/amd64/pmap.c
+++ b/sys/amd64/amd64/pmap.c
@@ -1611,8 +1611,8 @@ nkpt_init(vm_paddr_t addr)
 	 * Secondly, device memory mapped as part of setting up the low-
 	 * level console(s) is taken from KVA, starting at virtual_avail.
 	 * This is because cninit() is called after pmap_bootstrap() but
-	 * before vm_init() and pmap_init(). 20MB for a frame buffer is
-	 * not uncommon.
+	 * before vm_mem_init() and pmap_init(). 20MB for a frame buffer
+	 * is not uncommon.
 	 */
 	pt_pages += 32;		/* 64MB additional slop. */
 #endif
@@ -2451,7 +2451,8 @@ pmap_init_pv_table(void)
 
 /*
  *	Initialize the pmap module.
- *	Called by vm_init, to initialize any structures that the pmap
+ *
+ *	Called by vm_mem_init(), to initialize any structures that the pmap
  *	system needs to map virtual memory.
  */
 void
diff --git a/sys/amd64/conf/GENERIC b/sys/amd64/conf/GENERIC
index ab1c3856051b..38212dec294f 100644
--- a/sys/amd64/conf/GENERIC
+++ b/sys/amd64/conf/GENERIC
@@ -380,3 +380,6 @@ device		uinput			# install /dev/uinput cdev
 options 	HID_DEBUG		# enable debug msgs
 device		hid			# Generic HID support
 options 	IICHID_SAMPLING		# Workaround missing GPIO INTR support
+
+options		GDB
+options		DDB
